#!/usr/bin/perl

  ### Use the PAM perl module.
  use Authen::PAM;


  ### Include the standard library and define local variables.
  require './guardiandigital-lib.pl';
  &ReadParse();

  if (!$in{'fcn'}) {
    ### Get input variables.
    $pam_username = $ENV{'REMOTE_USER'};
    $pam_password = $in{'user_curpass'};
    $user_pass1   = $in{'user_pass1'};
    $user_pass2   = $in{'user_pass2'};


    ### Let's do the PAM thang.

    ### Start the PAM session, and set our username.
    $prv1 = pam_start("WebTool", $pam_username, \&pam_conv_func, $pamh);
    $prv2 = pam_set_item($pamh, PAM_USER, $pam_username);


    ### Define our state as authentication and execute.
    $pam_state = "AUTHENTICATE";
    $prv3 = pam_authenticate($pamh, 0);


    ### ############## ###
    ### ERROR CHECKING ###
    ### ############## ###

    ### Make sure the old password was entered.
    if (!$pam_password) {
      &PrintError("Please enter your old password.");
      exit;
    }

    ### Make sure the old password is correct.
    if ($prv3 != 0) {
      &PrintError("Your 'Old Password' is incorrect.  Please reenter.");
      exit;
    }

    ### Make sure we have two passwords.
    if (!$user_pass1 || !$user_pass2) {
      &PrintError("Please enter a new password in both fields.");
      exit;
    }

    ### Make sure passwords match.
    elsif ($user_pass1 ne $user_pass2) {
      &PrintError("The two passwords do not match.  Please reenter.");
      exit;
    }


   ### We have authenticated ourselves, so let's do the change then end.
   $prv4 = pam_chauthtok($pamh, 0);
   $prv5 = pam_end($pamh, 0);
  }


  ### Log out.
  open(LOGOUT, ">$miniserv{'logout'}");
    printf LOGOUT "%d\n", $ENV{'HTTP_USER_AGENT'} =~ /MSIE\s+4\./ ? 2 : 1;
  close(LOGOUT);


  ### Whisk us away somewhere.
  &redirect("/session_login.cgi?logout=1");



### ##################################################### ###
### The PAM conversation function for interactive logins. ###
### ##################################################### ###
sub pam_conv_func {
  my @res;

  while ( @_ ) {
    my $code = shift;
    my $msg = shift;
    my $ans = "";


    #$ans = $pam_password if ($code == PAM_PROMPT_ECHO_OFF() );

    if ($code == &PAM_PROMPT_ECHO_OFF) {
      if ($pam_state eq "AUTHENTICATE") {
        $pam_state = "CHAUTH-AUTHEN";
        $ans = $pam_password;
      }

      elsif ($pam_state eq "CHAUTH-AUTHEN") {
        $pam_state = "CHAUTHTOK";
        $ans = $pam_password;
      }
      else { $ans = $user_pass1; }
    }

    push @res, &PAM_SUCCESS;
    push @res, $ans;
  }

  get_out;
  push @res, &PAM_SUCCESS;
  return @res;
}
